#include<stdio.h>
#include<stdlib.h>
#include "types.h"
#include "warning.h"
#include "filer.h"

kq_filer *mf_otevri (char *nazev)
{
  kq_filer *vysledek;
  vysledek = (kq_filer *)mymalloc(sizeof(kq_filer));
  if((vysledek->file = fopen (nazev, "r")) == NULL)
    error ("mf_otevri(\"%s\")", nazev);

  vysledek->nazev = nazev;
  vysledek->x = 0;
  vysledek->y = 1;
  vysledek->ch = EOF;

  return vysledek;
}

void mf_zavri (kq_filer *soubor)
{
  fclose(soubor->file);
  free(soubor);
}

void mf_error (kq_filer *soubor)
{
  error("soubor:\"%s\", %d. radek, %d. znak",
	   soubor->nazev, soubor->y, soubor->x);
}

int mf_znak (kq_filer *soubor)
{
  int ch;

  if(soubor->ch != EOF){
    ch=soubor->ch;
    soubor->ch = EOF;
  }
  else{
    ch = fgetc(soubor->file);
  
    if(ch=='\n'){
      soubor->y++;
      soubor->x=0;
    }
    else soubor->x++;
  }
  return ch;
}

void mf_najdi (kq_filer *soubor, char znak)
{
  int ch;

  while((ch = mf_znak(soubor)) != znak)
    if(ch == EOF){
      warning("mf_najdi('%c')", znak);
      mf_error(soubor);
    }
}

void mf_musibyt (kq_filer *soubor, char *retezec)
{
  int i;
  for(i=0; retezec[i] != 0; i++)
    if(mf_znak(soubor) != retezec[i]){
      warning ("mf_musibyt(%s)", retezec);
      mf_error(soubor);
    }
}

int mf_cislo (kq_filer *soubor)
{
  int vysledek, ch;

  vysledek = mf_znak(soubor)-'0';
  if(vysledek < 0 || vysledek > 9){
    warning ("mf_cislo()");
    mf_error(soubor);
  }

  while((ch=mf_znak(soubor)) >= '0' && ch <= '9')
    vysledek = 10*vysledek+ch-'0';
  soubor->ch = ch;

  return vysledek;
}
