#include<sys/stat.h>
#include<sys/types.h>
#include<stdio.h>
#include<stdlib.h>
#include "defaults.h"
#include "types.h"
#include "mystring.h"
#include "warning.h"
#include "home.h"

void inithome ()
{
  char *homename;

  homename = getenv("HOME");
  if(homename == NULL){
    warning("neznam domovsky adresar");
    homedir = NULL;
  }
  else homedir = joinstrings(homename, "/", INHOMEDIR, NULL);
}

FILE *homefopen (const char *filename, const char *mode)
{
  FILE *vysledek;
  char *fullname;

  if(!homedir){
    warning("nebyl zjisten domovsky adresar");
    return NULL;
  }
  mkdir(homedir, 0777);

  fullname = joinstrings(homedir, "/", filename, NULL);
  vysledek = fopen(fullname, mode);
  free(fullname);
  return vysledek;
}
