#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "defaults.h"
#include "types.h"
#include "warning.h"
#include "pin.h"
#include "mystring.h"
#include "X.h"
#include "hash.h"
#include "popup.h"
#include "input.h"
#include "output.h"
#include "list.h"

void nactioutput (char *jazyk)
{
  char *fullname;
  char ch;
  char zacatekr = 1;
  char prazdnyr = 1;
  char mezera = 0;
  int pocetenteru = 0;
  int zadvojteckou = 0;

  kq_pin pin, *ppin;
  kq_string nekos;
  char *label;
  kq_list *oplist = NULL;
  kq_list *pom;
  kq_output *op = NULL;
  kq_output *pop;

  FILE *f;

  fullname = joinstrings(DATADIR, LANGDIR, jazyk, OUTPUTSUFFIX, NULL);
  if((f = fopen (fullname, "r")) == NULL){
    warning("Nepovedlo se otevrit soubor %s", fullname);
    free(fullname);
    return;
  }

  for(;;){
    ch = fgetc(f);

    if(zadvojteckou){
      while(ch == ' ' || ch == '\t') ch = fgetc(f);
      if(ch == '\n') ch = fgetc(f);
      else zacatekr = 0;
      zadvojteckou = 0;
    }

    if(ch == '\n'){
      if(prazdnyr){
	pocetenteru++;
	mezera = 0;
      }
      else{
	pocetenteru = 0;
	mezera = 1;
      }
      prazdnyr = 1;
      zacatekr = 1;
    }
    else if(ch == ' ' || ch == '\t'){
      if(!prazdnyr) mezera = 1;
      zacatekr = 0;
    }
    else if(zacatekr || ch == EOF){
      if(op){
	op->str = zestringuj(&nekos);
	for(pom = oplist; pom; pom = pom->next)
	  ((kq_output *)(pom->u.p))->str = op->str;
	smazlist(&oplist);
	smazstr(&nekos);
      }
      else initstr(&nekos);

      if(ch == EOF) return;

      op = (kq_output *)mymalloc(sizeof(kq_output));
      op->orig = 1;
      pop = op;

      for(;;){
	pop->slovo = NULL;

	mezera = 0;
	while(ch != EOF && ch != '\n' && ch != ':' && ch != ','){
	  if(ch == ' ' || ch == '\t') mezera = 1;
	  else{
	    if(mezera){
	      zapisznak(' ', &nekos);
	      mezera = 0;
	    }
	    zapisznak(ch, &nekos);
	  }
	  ch = fgetc(f);
	}
	label = zestringuj(&nekos);
	ppin = hash_find(OUTPUT, label);
	if(ppin){
	  if(ppin->typ != PINPOINTER) warning("nactioutput: spatny typ pinu");
	  pop->next = ppin->u.p;
	  ppin->u.p = pop;
	}
	else{
	  pin = pinpointer(pop);
	  hash_add(OUTPUT, label, &pin);
	  pop->next = NULL;
	}

	free(label);
	smazstr(&nekos);

	if(ch == ':'){
	  ch = fgetc(f);
	  while(ch != EOF && ch != '\n' && ch != ':' && ch != ','){
	    zapisznak(ch, &nekos);
	    ch = fgetc(f);
	  }
	  label = zestringuj(&nekos);
	  smazstr(&nekos);

	  upravstring(label);
	  if(label[0]){
	    ppin = hash_find(WORD, label);
	    if(ppin) pop->slovo = ((struct slovo *)ppin->u.p)->ulozeno;
	    if(!pop->slovo) warning("nepochopeno slovo %s v outputu", label);
	  }
	  free(label);
	  if(ch == ':') zadvojteckou = 1;
	}

	if(ch != ',') break;

	pop = (kq_output *)mymalloc(sizeof(kq_output));
	pop->orig = 0;
	addPdoL(pop, &oplist);
	ch = fgetc(f);
	while(ch == ' ' || ch == '\t' || ch == '\n') ch = fgetc(f);
      }

      zacatekr = prazdnyr = 1;
      mezera = 0;
      pocetenteru = 0;
    }
    else if(op){
      for(;pocetenteru; pocetenteru--) zapisznak('\n', &nekos);
      if(mezera){
	zapisznak(' ', &nekos);
	mezera = 0;
      }
      zapisznak(ch, &nekos);
      prazdnyr = 0;
    }
  }

  fclose(f);
  free(fullname);
}

char *outputstring (char *label, kq_word *slovo)
{
  kq_pin *pin;
  kq_output *pom;
  int pocet;

  pin = hash_find(OUTPUT, label);
  if(pin == NULL) return NULL;

  if(pin->typ != PINPOINTER){
    warning("spatny typ outputu");
    return NULL;
  }

  pocet = 0;
  for(pom = pin->u.p; pom; pom = pom->next)
    if(pom->slovo == slovo) pocet++;

  if(!pocet) return NULL;

  pocet = rand()%pocet;
  for(pom = pin->u.p; pom; pom = pom->next)
    if(pom->slovo == slovo){
      if(!pocet) break;
      pocet--;
    }

  if(!pom){
    warning("spatne spocteny nahodny output");
    return NULL;
  }

  return pom->str;
}

void popupwarning (char *label, char *unknown)
{
  char *str, *str2;
  int i, j;

  str = outputstring(label, NULL);
  if(!str){
    if(strcmp(label, "_unknown output")){
      popupwarning ("_unknown output", label);
      return;
    }
    else str = "unknown output: #";
  }

  j=1;
  for(i=0; str[i]; i++){
    if(str[i] == '#') j += strlen(unknown);
    else j++;
  }

  str2 = mymalloc(sizeof(char)*j);

  j=0;
  for(i=0; str[i]; i++){
    if(str[i] == '#'){
      strcpy(&str2[j], unknown);
      j += strlen(unknown);
    }
    else{
      str2[j] = str[i];
      j++;
    }
  }
  str2[j] = 0;

  popupstring(DEF_POP_SIRKA, DEF_POP_VYSKA, DEF_POP_X, DEF_POP_Y, str2);
  free(str2);
}

char popupoutput (char *label, kq_word *slovo,
		  float sirka, float vyska, float x, float y)
{
  char *str;

  str = outputstring(label, slovo);
  if(str) return popupstring(sirka, vyska, x, y, str);
  popupwarning("_unknown output", label);
  return 0;
}

char popup_info (char *label)
{
  return popupoutput(label, NULL, DEF_POP_SIRKA, DEF_POP_VYSKA, DEF_POP_X, DEF_POP_Y);
}
