#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<stdarg.h>
#include "types.h"
#include "pin.h"
#include "list.h"
#include "defaults.h"
#include "warning.h"
#include "mystring.h"
#include "input.h"
#include "pixmap.h"
#include "window.h"
#include "widget.h"
#include "timer.h"
#include "animwid.h"
#include "color.h"
#include "map.h"
#include "post.h"
#include "predmet.h"
#include "pol.h"

kq_policko *aktupol=NULL;
kq_policko *prvpol=NULL;
int pocet_pol = 0;

void (*pol_odchfunc)(kq_policko *odch, int smer, kq_policko **prich, int *x, int *y) = NULL;
void (*pol_prichfunc)(kq_policko *odch, int smer, kq_policko *prich) = NULL;

#define PW_PIX  1
#define PW_WID  2
#define PW_ANIM 3

static pol_widget *pospw;
static float rozdilz = 0;

kq_policko *newpol (char *jmpixmap, char *jmmapa,
		    int xa, int xb, int ya, int yb)
{
  int i;

  if(aktupol){
    aktupol->locbarva = prvbarva;
    prvbarva = globbarva;
    aktupol->next = (kq_policko *)mymalloc(sizeof(kq_policko));
    aktupol = aktupol->next;
  }
  else{
    globbarva = prvbarva;
    prvpol = aktupol = (kq_policko *)mymalloc(sizeof(kq_policko));
  }
  aktupol->Cislo = ++pocet_pol;
  aktupol->jmpixmap = jmpixmap;
  aktupol->jmmapa = jmmapa;
  aktupol->xa = xa;
  aktupol->xb = xb;
  aktupol->ya = ya;
  aktupol->yb = yb;
  aktupol->pw = NULL;
  aktupol->psm = NULL;
  aktupol->pp = NULL;
  aktupol->ps = NULL;
  aktupol->predmety = NULL;
  aktupol->odchfunc = NULL;
  aktupol->prichfunc = NULL;

  pospw = NULL;
  rozdilz = 0;

  aktupol->pocetanim = 0;
  for(i=0; i<4; i++) aktupol->vedle[i] = NULL;

  return aktupol;
}

static void pw_alloc ()
{
  pol_widget *pom;

  pom = (pol_widget *)mymalloc(sizeof(pol_widget));
  pom->next = NULL;
  if(pospw) pospw->next = pom;
  pospw = pom;
  if(!aktupol->pw) aktupol->pw = pom;
}

void pw_pix (char *nazev)
{
  pw_alloc();

  pospw->typ = PW_PIX;
  pospw->u.pixmap = dupstr(nazev);
}

void pw_wid (int x, int y, float z)
{
  pw_alloc();

  pospw->typ = PW_WID;
  pospw->u.widget.x = x;
  pospw->u.widget.y = y;
  pospw->u.widget.z = z;
  rozdilz = z-y;
}

void pw_xy (int x, int y)
{
  pw_alloc();

  pospw->typ = PW_WID;
  pospw->u.widget.x = x;
  pospw->u.widget.y = y;
  pospw->u.widget.z = y+rozdilz;
}  

void pw_anim (int x, int y, float z, float priorita, int opakovani, int prvpix, int prvcas, ...)
{
  va_list vl;
  int stav;
  pol_widget *puvanim;

  aktupol->pocetanim++;

  pw_alloc();

  pospw->typ = PW_ANIM;
  pospw->u.widget.x = x;
  pospw->u.widget.y = y;
  pospw->u.widget.z = z;

  pw_alloc();

  pospw->u.anim.priorita = priorita;
  pospw->u.anim.opakovani = opakovani;
  pospw->u.anim.pocet = 0;
  if(prvpix < 0) warning("malo policek animace");

  puvanim = pospw;

  va_start(vl, prvcas);
  stav = 0;
  while(prvpix >= 0){
    puvanim->u.anim.pocet++;
    if(stav){
      pospw->u.pokranim.pix2 = prvpix;
      pospw->u.pokranim.cas2 = prvcas;

      stav = 0;
    }
    else{
      pw_alloc();

      pospw->u.pokranim.pix1 = prvpix;
      pospw->u.pokranim.cas1 = prvcas;

      stav = 1;
    }
    prvpix = va_arg(vl, int);
    prvcas = va_arg(vl, int);
  }
  va_end(vl);
}

void pridej_pw (int x,int y, float z, char *nazev)
{
  pw_pix(nazev);
  pw_wid(x,y,z);
}

void pridej_psm (int x, int y, float z, char *nazev, char hide, kq_submap **ulozit)
{
  pol_submap *pom;

  pom = (pol_submap *)mymalloc(sizeof(pol_submap));
  pom->x = x;
  pom->y = y;
  pom->z = z;
  pom->filename = dupstr(nazev);
  pom->hide = hide;
  pom->ulozit = ulozit;
  pom->next = aktupol->psm;
  aktupol->psm = pom;
}

void pridej_pp (int x, int y, char smer, char hide, kq_postava **ulozit,
		float xz, float yz, float z,
		char *sm_nazev, int sm_x, int sm_y, float sm_z,
		char *a_nazev, int a_framu, char a_x, char a_y,
		char a_tim, char a_jednopol, char a_porad)
{
  pol_postava *pom;

  pom = (pol_postava *)mymalloc(sizeof(pol_postava));

  pom->x = x;
  pom->y = y;
  pom->smer = smer;
  pom->ulozit = ulozit;

  pom->xz = xz;
  pom->yz = yz;
  pom->z = z;

  if(sm_nazev){
    pom->sm_nazev = dupstr(sm_nazev);
    pom->sm_x = sm_x;
    pom->sm_y = sm_y;
    pom->sm_z = sm_z;
  }
  else pom->sm_nazev = NULL;

  pom->hide = hide;

  if(a_nazev){
    pom->a_nazev = dupstr(a_nazev);
    pom->a_framu = a_framu;
    pom->a_x = a_x;
    pom->a_y = a_y;
    pom->a_tim = a_tim;
    pom->a_jednopol = a_jednopol;
    pom->a_porad = a_porad;
  }
  else pom->a_nazev = NULL;

  pom->next = aktupol->pp;
  aktupol->pp = pom;
}

void pridej_ps (kq_word **w)
{
  kq_list *pom;

  pom = (kq_list *)mymalloc(sizeof(kq_list));
  pom->u.p = w;
  pom->next = aktupol->ps;
  aktupol->ps = pom;
}

static kq_pixmap *vylovpix (int cislo, int pocetpix)
{
  int i;
  kq_pixmap *vysledek;

  if(cislo <= 0){
    if(cislo < 0) warning("zaporne cislo pixmapy");
    return NULL;
  }
  else{
    if(cislo > pocetpix) warning("prilis velke cislo pixmapy");
    vysledek = prvpix;
    for(i=1; i<cislo; i++)
      if(vysledek) vysledek = vysledek->next;
    return vysledek;
  }
}    

static void pol_widgety ()
{
  pol_widget *pom;
  int pocetpixmap, pocetanim;
  int x,y; float z;
  float priorita, opakovani, pocet;
  int i;

  if(aktupol->pocetanim) animpole = mymalloc(aktupol->pocetanim*sizeof(kq_anim));

  pocetpixmap = pocetanim = 0;
  for(pom = aktupol->pw; pom; pom = pom->next){
    switch(pom->typ){
    case PW_PIX:
      nactikqXPM(pom->u.pixmap, 1);
      pocetpixmap++;
      break;
    case PW_WID:
      if(!pocetpixmap) warning("nebyla nactena pixmapa pred widgetem");
      vytvorwidget (pom->u.widget.x, pom->u.widget.y, pom->u.widget.z, prvpix, 1, -1);
      break;
    case PW_ANIM:
      if(pocetanim >= aktupol->pocetanim){
	pocetanim++;
	break;
      }
      x = pom->u.widget.x;
      y = pom->u.widget.y;
      z = pom->u.widget.z;

      pom = pom->next;
      if(!pom){
	warning("predcasne skoncene nacitani animace");
	break;
      }

      priorita = pom->u.anim.priorita;
      opakovani = pom->u.anim.opakovani;
      animpole[pocetanim].pocet = pocet = pom->u.anim.pocet;

      if(pocet == 0) warning("animace ma nula policek");
      else{
	animpole[pocetanim].pix = (kq_pixmap **)mymalloc(pocet*sizeof(kq_pixmap *));
	animpole[pocetanim].casy = (unsigned int *)mymalloc(pocet*sizeof(unsigned int));
      }

      for(i = 0; i<pocet; i++){
	if(i%2){
	  animpole[pocetanim].pix[i] = vylovpix(pom->u.pokranim.pix2, pocetpixmap);
	  animpole[pocetanim].casy[i] = pom->u.pokranim.cas2;
	}
	else{
	  pom = pom->next;
	  if(!pom){
	    warning("predcasne skoncene nacitani animace");
	    break;
	  }
	  animpole[pocetanim].pix[i] = vylovpix(pom->u.pokranim.pix1, pocetpixmap);
	  animpole[pocetanim].casy[i] = pom->u.pokranim.cas1;
	}
      }

      if(pocet) startanimwid(&animpole[pocetanim], x, y, z, priorita, opakovani, 1, -1);
	

      pocetanim++;
      break;

    default:
      warning("neznamy typ pol_widgetu");
    }
  }
}

static void pol_submapy ()
{
  pol_submap *pom;
  kq_submap *sm;

  for(pom = aktupol->psm; pom; pom = pom->next){
    sm = vytvorsubmap(pom->x, pom->y, pom->z, pom->filename, 1, pom->hide);
    if(pom->ulozit) *pom->ulozit = sm;
  }
}

static void pol_postavy ()
{
  pol_postava *pom;
  kq_postava *post;

  for(pom = aktupol->pp; pom; pom = pom->next){
    post = vytvorpost(pom->x, pom->y, pom->smer, 0, 0, 1, pom->hide);
    post_z(post, pom->xz, pom->yz, pom->z);

    if(pom->a_nazev)
      zmenanip(post, nactianip(pom->a_x, pom->a_y, pom->a_nazev, pom->a_framu,
			       pom->a_tim, pom->a_jednopol, pom->a_porad, 1));

    if(pom->sm_nazev) post_submap(post, pom->sm_nazev, pom->sm_x, pom->sm_y, pom->sm_z);

    if(pom->ulozit) *pom->ulozit = post;
  }
}

void vykreslipol ()
{
  kq_list *ps;

  for(ps=aktupol->ps; ps; ps = ps->next)
    if(ps->u.p) (*((kq_word **)(ps->u.p)))->kontext++;
  pol_postavy();

  zmenokno(aktupol->jmpixmap);
  pol_widgety();
  ukazwidgety();
  zobrazpredmety();

  zmenbgmap(aktupol->jmmapa);
  pol_submapy();
  reloadmap();

  autoreloadmap = 1;
}

void set_pol (kq_policko *pol)
{
  aktupol = pol;
  prvbarva = aktupol->locbarva;
  map_xa = aktupol->xa;
  map_xb = aktupol->xb;
  map_ya = aktupol->ya;
  map_yb = aktupol->yb;
}

char polvedle (kq_postava *post, int smer)
{
  int x,y,mx,my,vyhnout;
  kq_policko *npol, *opol;

  if(!aktupol->vedle[smer]) return 0;

  x = post->x;
  y = post->y;
  mx = 0;
  my = 0;
  switch(smer){
  case NAHORU:
    x+=post->xx;
    my = 1;
    y = -1;
    vyhnout=1;
    break;
  case DOLU:
    x+=post->xx;
    y=0;
    vyhnout=1;
    break;
  case VLEVO:
    mx = 1;
    x = -1;
    y+=post->yy;
    vyhnout=2;
    break;
  case VPRAVO:
    x=0;
    y+=post->yy;
    vyhnout=2;
    break;
  }
  npol = aktupol->vedle[smer];
  if(aktupol->odchfunc) aktupol->odchfunc(aktupol, smer, &npol, &x, &y);
  if(pol_odchfunc) pol_odchfunc(aktupol, smer, &npol, &x, &y);
  opol = aktupol;

  if(!post->zdi) vyhnout = 0;
  kql_square(post, npol, x, y, mx, my, vyhnout);

  if(npol->prichfunc) aktupol->prichfunc(opol, smer, npol);
  if(pol_prichfunc) pol_prichfunc(opol, smer, npol);

  return 1;
}

void kql_square (kq_postava *post, kq_policko *pol,
		 int px, int py, int mx, int my, int vyhnout)
{
  kq_color *b1;
  pol_submap *psm;
  pol_postava *pp;
  kq_list *ps;
  int x, y, x1, x2, ohide;

  if(post && post->lokalni > 0) post = NULL;

  if(post && mapa_z) b1 = mappixel(mapa, post->x,post->y);
  else b1 = NULL;

  autoreloadmap = 0;

  if(post && post->submap){
    ohide = post->submap->hide;
    hidesubmap(post->submap);
  }
  zmizpredmety();
  deletelanips();
  deletelposts();
  deletelsubmaps();
  deleteltimers();
  deletelwidgets();
  deletelpixmaps();
  free_animpole();
  for(psm=aktupol->psm; psm; psm = psm->next)
    if(psm->ulozit) *psm->ulozit = NULL;
  for(pp=aktupol->pp; pp; pp = pp->next)
    if(pp->ulozit) *pp->ulozit = NULL;
  for(ps=aktupol->ps; ps; ps = ps->next)
    if(ps->u.p) (*((kq_word **)(ps->u.p)))->kontext--;

  set_pol(pol);

  vykreslipol();

  if(!post) return;

  zmenapost(post);

  if(!mapa_z){
    post->x = px;
    post->y = py;    
    return;
  }

  x = mapa.sirka*mx + px;
  y = mapa.vyska*my + py;

  if(x<0) x=0;
  if(y<0) y=0;
  if(x>=mapa.sirka) x=mapa.sirka-1;
  if(y>=mapa.vyska) y=mapa.vyska-1;

  if(mappixel(mapa, x,y)->zed){
    if(vyhnout == 1)
      for(x1=x2=x; x1<mapa.sirka || x2>=0; x1++, x2--){
	if(x1<mapa.sirka && ! mappixel(mapa, x1,y)->zed){
	  x=x1;
	  break;
	}
	if(x2 >= 0 && ! mappixel(mapa, x2,y)->zed){
	  x=x2;
	  break;
	}
      }
    if(vyhnout == 2)
      for(x1=x2=y; x1<mapa.vyska || x2>=0; x1++, x2--){
	if(x1<mapa.vyska && ! mappixel(mapa, x,x1)->zed){
	  y=x1;
	  break;
	}
	if(x2 >= 0 && ! mappixel(mapa, x,x2)->zed){
	  y=x2;
	  break;
	}
      }
  }

  post->x = x;
  post->y = y;
  if(post->submap){
    post->submap->x = x-post->sm_x;
    post->submap->y = x-post->sm_y;
    if(ohide) unhidesubmap(post->submap);
  }

  if(post->barvy && b1) spustfb(post, mappixel(mapa, x,y), b1);
}

void prvnipol ()
{
  kq_list *ps;

  zmenbgmap(aktupol->jmmapa);
  reloadmap();
  autoreloadmap = 1;

  for(ps=aktupol->ps; ps; ps = ps->next)
    if(ps->u.p) (*((kq_word **)(ps->u.p)))->kontext++;
  pol_postavy();
  pol_widgety();
  pol_submapy();
  zobrazpredmety();

  vytvorokno(aktupol->jmpixmap);
  ukazwidgety();
}

void spojpol (kq_policko **pole, int sirka, int vyska,
	                         int htorus, int vtorus)
{
  int i,j;

  for(i=0; i<vyska; i++)
    for(j=0; j<sirka*vyska; j += vyska){
      if(pole[i + j]){
	if(i==0){
	  if(vtorus) pole[i + j]->vedle[NAHORU] = pole[vyska-1 + j];
	}
	else pole[i + j]->vedle[NAHORU] = pole[i-1 + j];
	if(i==vyska-1){
	  if(vtorus) pole[i + j]->vedle[DOLU] = pole[j];
	}
	else pole[i + j]->vedle[DOLU] = pole[i+1 + j];
	if(j==0){
	  if(htorus) pole[i + j]->vedle[VLEVO] = pole[i + vyska*(sirka-1)];
	}
	else pole[i + j]->vedle[VLEVO] = pole[i + j-vyska];
	if(j==vyska*(sirka-1)){
	  if(htorus) pole[i + j]->vedle[VPRAVO] = pole[i];
	}
	else pole[i + j]->vedle[VPRAVO] = pole[i + j+vyska];
      }
    }
}

void free_animpole ()
{
  int i;

  if(!aktupol->pocetanim) return;
  for(i = 0; i<aktupol->pocetanim; i++){
    free(animpole[i].pix);
    free(animpole[i].casy);
  }
  free(animpole);
}
