#include<stdio.h>
#include<stdlib.h>
#include "types.h"
#include "defaults.h"
#include "warning.h"
#include "mystring.h"
#include "pixmap.h"
#include "widget.h"
#include "pin.h"
#include "timer.h"
#include "color.h"
#include "map.h"
#include "post.h"
#include "autopost.h"
#include "pol.h"

kq_animpost *prvanip = NULL;
kq_postava *prvpost = NULL;
char menpost = 0;

kq_animpost *nactianip (int x, int y, char *nazev, int framu, int tim,
			char jednopol, char porad, char lokalni)
{
  int i, pocetpix;
  char cistr[20], *fullname;
  kq_animpost *vysledek;

  if(framu < 1){
    warning("nactianip: framu=%d < 1  ==>  framu=1", framu);
    framu = 1;
  }

  vysledek = (kq_animpost *)mymalloc(sizeof(kq_animpost));
  vysledek->x = x;
  vysledek->y = y;
  vysledek->framu = framu;
  vysledek->tim = tim;
  vysledek->jednopol = jednopol;
  vysledek->porad = porad;
  vysledek->lokalni = lokalni;

  if(jednopol) pocetpix = framu;
  else pocetpix = framu*4;

  if(pocetpix > 1) vysledek->pix.pole = (kq_pixmap **)mymalloc(pocetpix * sizeof(kq_pixmap *));

  if(jednopol){
    if(framu > 1)
      for(i = 0; i < framu; i++){
	sprintf(cistr, "%d", i);
	fullname = joinstrings(ANIPDIR, nazev, ANIPSTR, cistr, NULL);
	vysledek->pix.pole[i] = nactikqXPM(fullname, lokalni);
	free(fullname);
      }
    else{
      fullname = joinstrings(ANIPDIR, nazev, NULL);
      vysledek->pix.map = nactikqXPM(fullname, lokalni);
    }
  }
  else{
    for(i = framu*NAHORU; i < (NAHORU+1)*framu; i++){
      if(framu == 1) cistr[0] = 0;
      else sprintf(cistr, "%d", i - framu*NAHORU);

      fullname = joinstrings(ANIPDIR, nazev, UPSTR, cistr, NULL);
      vysledek->pix.pole[i] = nactikqXPM(fullname, lokalni);
      free(fullname);
    }
    for(i = framu*DOLU; i < (DOLU+1)*framu; i++){
      if(framu == 1) cistr[0] = 0;
      else sprintf(cistr, "%d", i - framu*DOLU);

      fullname = joinstrings(ANIPDIR, nazev, DOWNSTR, cistr, NULL);
      vysledek->pix.pole[i] = nactikqXPM(fullname, lokalni);
      free(fullname);
    }
    for(i = framu*VLEVO; i < (VLEVO+1)*framu; i++){
      if(framu == 1) cistr[0] = 0;
      else sprintf(cistr, "%d", i - framu*VLEVO);

      fullname = joinstrings(ANIPDIR, nazev, LEFTSTR, cistr, NULL);
      vysledek->pix.pole[i] = nactikqXPM(fullname, lokalni);
      free(fullname);
    }
    for(i = framu*VPRAVO; i < (VPRAVO+1)*framu; i++){
      if(framu == 1) cistr[0] = 0;
      else sprintf(cistr, "%d", i - framu*VPRAVO);

      fullname = joinstrings(ANIPDIR, nazev, RIGHTSTR, cistr, NULL);
      vysledek->pix.pole[i] = nactikqXPM(fullname, lokalni);
      free(fullname);
    }
  }

  vysledek->next = prvanip;
  prvanip = vysledek;

  return vysledek;
}

void zmenanip (kq_postava *post, kq_animpost *anip)
{
  if(anip == post->animace) return;

  if(post->animtim) znictimer(post->animtim);
  post->animtim = NULL;
  post->animace = anip;
  if(anip){
    if(anip->tim > 0){
      post->animtim = vytvortimer(&anip_step, pinpointer(post), anip->tim, ANIMPRIOR,
				  0, post->lokalni, post->hide);
    }
    post->animstav %= anip->framu;
  }
  zmenapost(post);
}

static float spocti_z (kq_postava *post)
{
  return post->xz*post->x + post->yz*post->y + post->z;
}

void anip_step (kq_postava *post)
{
  if(!post->animace || post->animace->framu == 1) return;
  if(!post->animace->porad && !post->xx && !post->yy) return;

  if(post->animace->jednopol < 0){
    post->animstav = ((int)(spocti_z(post)*10)) % post->animace->framu;
    if(post->animstav < 0) post->animstav += post->animace->framu;
  }

  post->animstav++;
  if(post->animstav >= post->animace->framu) post->animstav = 0;

  zmenapost(post);
}

void freeanip (kq_animpost *anip)
{
  int i;
  kq_animpost **pom;

  for(pom = &prvanip; *pom && *pom != anip; pom = &(*pom)->next);
  if(!pom){
    warning("freeanip: animace postavy nenalezena v seznamu");
    return;
  }
  *pom = anip->next;

  i = anip->framu;
  if(!anip->jednopol) i *= 4;

  if(i == 1) freekqPixmap(anip->pix.map);
  else if(i > 1){
    while(i) freekqPixmap(anip->pix.pole[--i]);
    free(anip->pix.pole);
  }
  free(anip);
}

void deletelanips ()
{
  kq_animpost **pom, *pomo, *pomoc;

  for(pom = &prvanip;; pom = &pomo->next){
    for(pomo = *pom; pomo && pomo->lokalni; pomo = pomoc){
      pomoc = pomo->next;
      if(pomo->framu > 1 || (pomo->framu == 1 && !pomo->jednopol))
	free(pomo->pix.pole);
      free(pomo);
    }
    *pom = pomo;
    if(!pomo) break;
  }
}

void deleteAanips ()
{
  kq_animpost *pom;

  while(prvanip){
    pom = prvanip->next;
    if(prvanip->framu > 1 || (prvanip->framu == 1 && !prvanip->jednopol))
      free(prvanip->pix.pole);
    free(prvanip);
    prvanip = pom;
  }
}

kq_animpost *fixed_anips = NULL;
int pocet_fixanips = 0;

void fix_anips ()
{
  kq_animpost *pom;

  if(pocet_fixanip) warning("funkce fix_anips() je spustitelna jen jednou");

  for(pom = prvanip; pom; pom = pom->next) pom->Cislo = --pocet_fixanip;
  fixed_anips = prvanip;
  prvanip = NULL;

  fix_pix();
}

kq_postava *vytvorpost (int x, int y, int smer, int tim,
			float tprior, char lokalni, char hide)
{
  kq_postava *vysledek;

  vysledek = (kq_postava *)mymalloc(sizeof(kq_postava));
  vysledek->x = x;
  vysledek->y = y;
  vysledek->xx = 0;
  vysledek->yy = 0;
  vysledek->zdi = 1;
  vysledek->odraz = 0;
  vysledek->barvy = 1;
  vysledek->odejde = 1;
  vysledek->submap = NULL;
  vysledek->sm_x = 0;
  vysledek->sm_y = 0;

  setchytsour(vysledek, 0, 0);

  vysledek->chyt_vzdal = 0;
  vysledek->chyt_func = NULL;

  vysledek->auto_func = NULL;
  vysledek->auto_tim = NULL;

  vysledek->free_func = NULL;

  vysledek->animace = NULL;
  vysledek->smer = smer;
  vysledek->animstav = 0;
  vysledek->animtim = NULL;

  post_z(vysledek, 0, 0, 0);

  vysledek->lokalni = lokalni;
  vysledek->hide = hide;
  vysledek->zmena = 0;

  vysledek->widget = vytvorwidget(0, 0, 0, NULL, lokalni, hide);
  if(tim > 0) 
    vysledek->tim = vytvortimer(&jdipost, pinpointer(vysledek), tim, tprior, 0, lokalni, hide);
  else vysledek->tim = NULL;

  vysledek->next = prvpost;
  prvpost = vysledek;

  return vysledek;
}

void zmenapost (kq_postava *post)
{
  menpost = 1;
  post->zmena = 1;
}

void updateposts ()
{
  kq_pixmap *pix;
  int x, y;
  float z;
  kq_postava *pom;

  if(!menpost) return;
  for(pom = prvpost; pom; pom = pom->next)
    if(pom->zmena){
      if(pom->hide){
	hidewidget(pom->widget);
	continue;
      }
      if(pom->animace){
	x = pom->x * map_xa + map_xb - pom->animace->x;
	y = pom->y * map_ya + map_yb - pom->animace->y;
	z = spocti_z(pom);
	if(pom->animace->framu == 1 && pom->animace->jednopol)
	  pix = pom->animace->pix.map;
	else{
	  if(pom->animace->jednopol) pix = pom->animace->pix.pole[pom->animstav];
	  else pix = pom->animace->pix.pole[pom->smer*pom->animace->framu + pom->animstav];
	}
	zmenwidget(pom->widget, x, y, z, pix);
      }
      else prebarviwidget(pom->widget, NULL);

      if(!pom->hide) unhidewidget(pom->widget);

      pom->zmena = 0;
    }

  menpost = 0;
}

void zkuschytit (kq_postava *post)
{
  int x, y;

  if(post->chyt_func && !post->hide){
    getchytsour(post, &x, &y);
    if(post->chyt_vzdal >= vzdalenost(x,y,post->x, post->y))
      post->chyt_func(post);
  }  
}

int posunpost (kq_postava *post, int x, int y)
{
  int ohide;
  kq_color *nbarva, *obarva;
  char navrat;

  if(x<0 || x>=mapa.sirka || y<0 || y>=mapa.vyska) return 0;

  navrat = 1;

  if(mapa_z){
    if(post->submap){
      ohide = post->submap->hide;
      hidesubmap(post->submap);
    }
    obarva = mappixel(mapa, post->x, post->y);
    nbarva = mappixel(mapa, x, y);
    if(mappixel(mapa, x,y)->zed && post->zdi) navrat = 0;
    else{
      post->x = x;
      post->y = y;
      if(post->submap){
	post->submap->x = x-post->sm_x;
	post->submap->y = y-post->sm_y;
      }
    }
    if(post->submap && !ohide) unhidesubmap(post->submap);

    if(post->barvy) spustfb(post, nbarva, obarva);
  }
  else{
    post->x = x;
    post->y = y;
  }    

  if(navrat){
    zmenapost(post);
    zkuschytit(post);
  }

  return navrat;
}

void jdipost (kq_postava *post)
{
  char smer, sel;
  int x, y;

  if(post->auto_func && !post->auto_tim) post->auto_func(post);

  if(post->xx || post->yy){
    if(post->xx < 0) smer = VLEVO;
    else if(post->xx > 0) smer = VPRAVO;
    else if(post->yy < 0) smer = NAHORU;
    else if(post->yy > 0) smer = DOLU;

    if(post->smer != smer){
      post->smer = smer;
      zmenapost(post);
    }

    x = post->x + post->xx;
    y = post->y + post->yy;

    if(mapa_z && (x<0 || x>=mapa.sirka || y<0 || y>=mapa.vyska)){
      if(post->odejde){
	if(post->lokalni){
	  if(post->lokalni > 0){
	    znicpost(post);
	    return;
	  }
	  else hidepost(post);
	  sel = 0;
	}
	else{
	  if(x<0)                sel = polvedle(post, VLEVO);
	  else if(x>=mapa.sirka) sel = polvedle(post, VPRAVO);
	  else if(y<0)           sel = polvedle(post, NAHORU);
	  else                   sel = polvedle(post, DOLU);
	}
      }
      else sel = 0;
    }
    else sel = posunpost(post, x, y);
    if(!sel){
      if(post->odraz){
	if(x<0 || x>=mapa.sirka) post->xx *= -1;
	else if(y<0 || y>=mapa.vyska) post->yy *= -1;
	else{
	  post->xx *= -1;
	  post->yy *= -1;
	}
      }
      else{
	post->xx = 0;
	post->yy = 0;
      }
    }
  }

  if(!post->animtim) anip_step(post);
}

void hidepost (kq_postava *post)
{
  post->hide = 1;
  if(post->submap) hidesubmap(post->submap);
  if(post->tim) pausetimer(post->tim);
  if(post->animtim) pausetimer(post->animtim);
  if(post->auto_tim) pausetimer(post->auto_tim);

  zmenapost(post);
}

void unhidepost (kq_postava *post)
{
  post->hide = 0;
  if(post->submap) unhidesubmap(post->submap);
  if(post->tim) unpausetimer(post->tim);
  if(post->animtim) unpausetimer(post->animtim);
  if(post->auto_tim) unpausetimer(post->auto_tim);
  zkuschytit(post);

  zmenapost(post);
}

void znicpost (kq_postava *post)
{
  kq_postava **pom;

  if(post->submap) znicsubmap(post->submap);
  if(post->tim) znictimer(post->tim);
  if(post->animtim) znictimer(post->animtim);
  if(post->auto_tim) znictimer(post->auto_tim);
  znicwidget(post->widget);

  for(pom = &prvpost; *pom && *pom!=post; pom = &((*pom)->next));
  if(*pom){
    *pom = post->next;
    if(post->free_func) post->free_func(post);
    free(post);
  }
  else{
    warning("znicpost: postava nenalezena v seznamu");
  }
}

void deletelposts ()
{
  kq_postava **pom, *pomo, *pomoc;

  for(pom = &prvpost;; pom = &pomo->next){
    for(pomo = *pom; pomo && pomo->lokalni > 0; pomo = pomoc){
      pomoc = pomo->next;
      if(pomo->free_func) pomo->free_func(pomo);
      free(pomo);
    }
    *pom = pomo;
    if(!pomo) break;
    if(pomo->lokalni < 0){
      pomo->hide = 1;
      zmenapost(pomo);
    }
  }
}

void deleteAposts ()
{
  kq_postava *pom;

  while(prvpost){
    pom = prvpost->next;
    free(prvpost);
    prvpost = pom;
  }
}

void post_submap (kq_postava *post, char *nazev, int x, int y, float z)
{
  if(post->submap) znicsubmap(post->submap);

  post->sm_x = x;
  post->sm_y = y;
  post->submap = vytvorsubmap(post->x-x, post->y-y, z, nazev, post->lokalni, post->hide);
}

void post_z (kq_postava *post, float xz, float yz, float z)
{
  post->xz = xz;
  post->yz = yz;
  post->z = z;

  post->zmena = 1;
  menpost = 1;
}

void getchytsour (kq_postava *post, int *x, int *y)
{
  if(post->autou_typ == AUTOU_SOUR){
    if(x) *x = post->auto_u.sourad.x;
    if(y) *y = post->auto_u.sourad.y;
    return;
  }
  if(post->autou_typ == AUTOU_POST){
    if(x) *x = post->auto_u.sledpost->x;
    if(y) *y = post->auto_u.sledpost->y;
    return;
  }

  warning("neznamy typ souradnic: %d", post->autou_typ);
  if(x) x = 0;
  if(y) y = 0;
}

void setchytsour (kq_postava *post, int x, int y)
{
  post->autou_typ = AUTOU_SOUR;
  post->auto_u.sourad.x = x;
  post->auto_u.sourad.y = y;
}

void setchytpost (kq_postava *post, kq_postava *sledpost)
{
  post->autou_typ = AUTOU_POST;
  post->auto_u.sledpost = sledpost;
}

void autopost (kq_postava *post, void (*auto_func)(kq_postava *post), int prvcas, int cas)
{
  if(post->auto_tim) znictimer(post->auto_tim);

  post->auto_func = auto_func;
  if(auto_func != NULL && cas){
    post->auto_tim = vytvortimer(auto_func, pinpointer(post), prvcas,
				 AUTOPRIOR, 0, post->lokalni, post->hide);
    post->auto_tim->cas = cas;
  }
  else post->auto_tim = NULL;
}
